function output =mktl_test(model)
% multi kernel transfer learning testing function 
%   -- modified from the OBSCURE code in the DOGMA library


% This code is part of the supplementary material to the ICCV 2011 paper
% "Multiclass Transfer Learning from Unconstrained Priors", L. Jie*, T.
% Tommasi*, B. Caputo (* equal authorship). 

% Copyright (C) 2010-2011, Tatiana Tommasi
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%
% Contact the authors: ttommasi [at] idiap.ch , jluo [at] idiap.ch


% test file 
global Ktest Ytest Ptest

acc  = zeros(1, 2);
n_test = size(Ktest, 2);

out_p = zeros(model.n_cla, n_test);
for i=1:n_test
  out_p(:, i) = sum(model.beta_p.*repmat(Ptest(:, i)', model.n_cla, 1).*model.weights_p, 2);
end

if isa(Ktest, 'single')
  out_k = full(model.beta_k) * kbeta_single(Ktest, model.weights_k);
else
  out_k = full(model.beta_k) * kbeta_double(Ktest, model.weights_k);
end

out   = out_p + out_k;
[mx,pred]=max(out,[],1);
[mx, pred] = max(out, [], 1);
acc = stat_acc(pred, Ytest');
fprintf('\t Accuracy : %.2f\n', acc(2)*100);
output.acc = acc;

function acc = stat_acc(yhat, y)
acc(1) =numel(find(yhat==y))/numel(y);
acc_cls = zeros(max(y),1);
for i=1:max(y)
    idx = find(y == i);
    acc_cls(i) = numel(find(yhat(idx) == y(idx)))/numel(idx);
end
acc(2) = mean(acc_cls);
